--- old/usr/src/uts/armv6/loader/fakeloader.c	2015-02-12 20:32:16.820301208 -0500
+++ new/usr/src/uts/armv6/loader/fakeloader.c	2015-02-12 20:32:16.827689834 -0500
@@ -35,7 +35,7 @@
  *   		- boot_archive
  *   		- atags
  *   o Enable unaligned access
- *   o Enable the caches + virtual memory
+ *   o Enable virtual memory
  *
  * There are several important constraints that we have here:
  *
@@ -163,11 +163,18 @@
 	l1e = (arm_l1s_t *)pte;
 	*pte = 0;
 	l1e->al_type = ARMPT_L1_TYPE_SECT;
-	/* Assume it's not device memory */
-	l1e->al_bbit = 1;
-	l1e->al_cbit = 1;
-	l1e->al_tex = 1;
-	l1e->al_sbit = 1;
+
+	if (prot & PF_DEVICE) {
+		l1e->al_bbit = 1;
+		l1e->al_cbit = 0;
+		l1e->al_tex = 0;
+		l1e->al_sbit = 1;
+	} else {
+		l1e->al_bbit = 1;
+		l1e->al_cbit = 1;
+		l1e->al_tex = 1;
+		l1e->al_sbit = 1;
+	}
 
 	if (!(prot & PF_X))
 		l1e->al_xn = 1;
@@ -446,7 +453,7 @@
 
 			if (!(vstart & MMU_PAGEOFFSET1M) &&
 			    !(pstart & MMU_PAGEOFFSET1M) &&
-			    len == MMU_PAGESIZE1M) {
+			    len >= MMU_PAGESIZE1M) {
 				fakeload_map_1mb(pstart, vstart, prot);
 				vstart += MMU_PAGESIZE1M;
 				pstart += MMU_PAGESIZE1M;
@@ -703,10 +710,6 @@
 
 	FAKELOAD_DPRINTF("why helo thar\n");
 
-	/* Renable caches */
-	armv6_dcache_enable();
-	armv6_icache_enable();
-
 	/* we should never come back */
 	fakeload_exec(ident, ident2, chain, unix_start);
 	fakeload_panic("hit the end of the world\n");
